Error editing (drawing) verctorial layers
01/29/2014 09:45 AM - Jose Manuel Vivó Arnal

Status: Closed % Done: 0%
Priority: Normal Spent time: 0.00 hour
Assignee: Juan Lucas Domínguez
Category: Vector editing
Target version: 2.1.0-2218-testing
Severity: Add-on version:
gvSIG version: 2.1.0 Add-on build:
gvSIG build: 2217 Add-on resolve version:
Operative System: Linux Add-on resolve build:
Keywords: Proyecto:
Has patch: No Hito:
Add-on name: Unknown
Description

When I have been editing two vectorial layer, an exception has been throw:

java.lang.InternalError: Cannot construct MaskBlit for XOR mode
    at sun.java2d.loops.MaskBlit.makePrimitive(MaskBlit.java:110)
    at sun.java2d.loops.GraphicsPrimitiveMgr.locate(GraphicsPrimitiveMgr.java:145)
    at sun.java2d.loops.MaskBlit.locate(MaskBlit.java:43)
    at sun.java2d.loops.MaskBlit.getFromCache(MaskBlit.java:56)
    at sun.java2d.pipe.AlphaPaintPipe.renderPathTile(AlphaPaintPipe.java:149)
    at sun.java2d.pipe.DuctusShapeRenderer.renderTiles(DuctusShapeRenderer.java:147)
    at sun.java2d.pipe.DuctusShapeRenderer.fillParallelogram(DuctusShapeRenderer.java:75)
    at sun.java2d.pipe.PixelToParallelogramConverter.fillRectangle(PixelToParallelogramConverter.java:298)
    at sun.java2d.pipe.PixelToParallelogramConverter.fillRect(PixelToParallelogramConverter.java:97)
    at sun.java2d.pipe.ValidatePipe.fillRect(ValidatePipe.java:58)
    at sun.java2d.SunGraphics2D.fillRect(SunGraphics2D.java:2278)
    at org.gvsig.fmap.mapcontrol.impl.MapControlDrawer2D.drawHandlers(MapControlDrawer2D.java:93)
    at org.gvsig.editing.layers.VectorialLayerEdited.drawHandlers(VectorialLayerEdited.java:358)
    at org.gvsig.editing.layers.VectorialLayerEdited.afterLayerDraw(VectorialLayerEdited.java:398)
    at org.gvsig.fmap.mapcontext.MapContext.fireLayerDrawingEvent(MapContext.java:669)
    at org.gvsig.fmap.mapcontext.layers.FLayers.endDraw(FLayers.java:1317)
    at org.gvsig.fmap.mapcontext.impl.DefaultMapContextDrawer$DrawList.drawLayers(DefaultMapContextDrawer.java:437)
    at org.gvsig.fmap.mapcontext.impl.DefaultMapContextDrawer.draw(DefaultMapContextDrawer.java:151)
    at org.gvsig.fmap.mapcontext.MapContext.draw(MapContext.java:1093)
    at org.gvsig.fmap.mapcontrol.MapControl$PaintingRequest.paint(MapControl.java:1332)
    at org.gvsig.fmap.mapcontrol.MapControl$Drawer$Worker.run(MapControl.java:1552)
    at java.lang.Thread.run(Thread.java:662)

After that, gvSIG freezes.

Log file and screen snapshot attached.

History
#1 - 01/29/2014 09:48 AM - Álvaro Anguix
- Assignee set to Juan Lucas Domínguez
- Target version set to 2.1.0-2219-testing

Si puedes contar los pasos para intentar reproducir el error, se agradece.
:-)

#2 - 01/29/2014 10:48 AM - Jose Manuel Vivó Arnal

Pues va a ser difícil... A ver:

    1. Añadidas 3 capas a la vista (1 postgis + 2 shp aunque creo que no tiene que ver con eso)
    2. Iniciada edición de los Shapes
    3. Abiertas las tablas de atributos de las capas seleccionadas
    4. Mover la tabla de atributos sobre la vista

Por la traza y por como se ha quedado la aplicación, yo diría que el error se ha producido al pintar un handler de la geometría seleccionada de la capa
en edición cuando el borde de la tabla de atributos a pasado por encima.

Creo que será muy difícil reproducirlo. Igual es un bug de la propia JRE de oracle (en vista en el paquete que aparece). Lo que creo que se podría
hacer es echar un vistazo al método de pintado de handlers para intentar atrapar esta excepción.

#3 - 01/30/2014 10:33 AM - Juan Lucas Domínguez
- Status changed from New to Fixed

Catching and ignoring graphical 'InternalError' experienced by jmvivo. Probably happens only with certain JRE or OS.

gvsig-desktop:r41102

#4 - 01/30/2014 10:39 AM - Álvaro Anguix
- Target version changed from 2.1.0-2219-testing to 2.1.0-2218-testing

#5 - 02/01/2014 05:11 PM - Álvaro Anguix
- Status changed from Fixed to Closed
